osg::MatrixTemplate< T, RowN, ColN > Class Template Reference

`#include <Uniform>`

Inheritance diagram for osg::MatrixTemplate< T, RowN, ColN >:

## Public Types

enum | { col_count = ColN }
enum | { row_count = RowN }
enum | { value_count = ColN * RowN }
typedef T | value_type

## Public Member Functions

| MatrixTemplate ()
| ~MatrixTemplate ()
value_type & | operator() (int row, int col)
value_type | operator() (int row, int col) const
MatrixTemplate & | operator= (const MatrixTemplate &rhs)
void | set (const MatrixTemplate &rhs)
void | set (value_type const *const ptr)
value_type * | ptr ()
const value_type * | ptr () const
value_type & | operator[] (int i)
value_type | operator[] (int i) const
void | reset ()

## Protected Attributes

value_type | _mat [row_count][col_count]

## Member Typedef Documentation

## value_type

template<typename T, unsigned int RowN, unsigned int ColN>

typedef T osg::MatrixTemplate< T, RowN, ColN >::value_type

## Member Enumeration Documentation

## anonymous enum

template<typename T, unsigned int RowN, unsigned int ColN>

anonymous enum

Enumerator
row_count |

## anonymous enum

template<typename T, unsigned int RowN, unsigned int ColN>

anonymous enum

Enumerator
value_count |

## anonymous enum

template<typename T, unsigned int RowN, unsigned int ColN>

anonymous enum

Enumerator
col_count |

## Constructor & Destructor Documentation

## MatrixTemplate()

template<typename T, unsigned int RowN, unsigned int ColN>

osg::MatrixTemplate< T, RowN, ColN >::MatrixTemplate | ( |  | ) |

inline

## ~MatrixTemplate()

template<typename T, unsigned int RowN, unsigned int ColN>

osg::MatrixTemplate< T, RowN, ColN >::~MatrixTemplate | ( |  | ) |

inline

## Member Function Documentation

## operator()() [1/2]

template<typename T, unsigned int RowN, unsigned int ColN>

value_type & osg::MatrixTemplate< T, RowN, ColN >::operator() | ( | int | row,
|  | int | col )

inline

## operator()() [2/2]

template<typename T, unsigned int RowN, unsigned int ColN>

value_type osg::MatrixTemplate< T, RowN, ColN >::operator() | ( | int | row,
|  | int | col ) const

inline

## operator=()

template<typename T, unsigned int RowN, unsigned int ColN>

MatrixTemplate & osg::MatrixTemplate< T, RowN, ColN >::operator= | ( | const MatrixTemplate< T, RowN, ColN > & | rhs | ) |

inline

## operator[]() [1/2]

template<typename T, unsigned int RowN, unsigned int ColN>

value_type & osg::MatrixTemplate< T, RowN, ColN >::operator[] | ( | int | i | ) |

inline

## operator[]() [2/2]

template<typename T, unsigned int RowN, unsigned int ColN>

value_type osg::MatrixTemplate< T, RowN, ColN >::operator[] | ( | int | i | ) | const

inline

## ptr() [1/2]

template<typename T, unsigned int RowN, unsigned int ColN>

value_type * osg::MatrixTemplate< T, RowN, ColN >::ptr | ( |  | ) |

inline

Referenced by osg::Matrix2Template< float >::Matrix2Template(), osg::Matrix2x3Template< float >::Matrix2x3Template(), osg::Matrix2x4Template< float >::Matrix2x4Template(), osg::Matrix3Template< float >::Matrix3Template(), osg::Matrix3x2Template< float >::Matrix3x2Template(), osg::Matrix3x4Template< float >::Matrix3x4Template(), osg::Matrix4x2Template< float >::Matrix4x2Template(), osg::Matrix4x3Template< float >::Matrix4x3Template(), osg::MatrixTemplate< T, 2, 2 >::operator=(), osg::MatrixTemplate< T, 2, 2 >::operator[](), osg::MatrixTemplate< T, 2, 2 >::operator[](), and osg::MatrixTemplate< T, 2, 2 >::set().

## ptr() [2/2]

template<typename T, unsigned int RowN, unsigned int ColN>

const value_type * osg::MatrixTemplate< T, RowN, ColN >::ptr | ( |  | ) | const

inline

## reset()

template<typename T, unsigned int RowN, unsigned int ColN>

void osg::MatrixTemplate< T, RowN, ColN >::reset | ( |  | ) |

inline

## set() [1/2]

template<typename T, unsigned int RowN, unsigned int ColN>

void osg::MatrixTemplate< T, RowN, ColN >::set | ( | const MatrixTemplate< T, RowN, ColN > & | rhs | ) |

inline

Referenced by osg::MatrixTemplate< T, 2, 2 >::operator=(), and osg::MatrixTemplate< T, 2, 2 >::set().

## set() [2/2]

template<typename T, unsigned int RowN, unsigned int ColN>

void osg::MatrixTemplate< T, RowN, ColN >::set | ( | value_type const *const | ptr | ) |

inline

## Member Data Documentation

## _mat

template<typename T, unsigned int RowN, unsigned int ColN>

value_type osg::MatrixTemplate< T, RowN, ColN >::_mat[row_count][col_count]

protected

Referenced by osg::Matrix2Template< float >::set(), osg::Matrix2x3Template< float >::set(), osg::Matrix2x4Template< float >::set(), osg::Matrix3Template< float >::set(), osg::Matrix3x2Template< float >::set(), osg::Matrix3x4Template< float >::set(), osg::Matrix4x2Template< float >::set(), and osg::Matrix4x3Template< float >::set().

The documentation for this class was generated from the following file:

- Uniform